﻿;==========================================================================================================================================================
; Search recipes in linked list and display matches
;==========================================================================================================================================================

Procedure SearchRecipes()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If GetActiveGadget()  = #Gadget_Recipeview_Recipesearch
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    PseudoCounter.i = 0
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SearchText.s = LCase(GetGadgetText(#Gadget_Recipeview_Recipesearch))
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    If Len(SearchText.s)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      Program\LastStringSearched.s  = SearchText.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_Recipeview_Recipenames)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Recipeview_Recipesearch, #Empty$)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      If Left(SearchText.s, 2) = "//"
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        ForEach Recipes()
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
          SearchText.s = RemoveString(SearchText.s, "//", #PB_String_NoCase, 1)
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
          If FindString(Recipes()\RecipeCategory.s, SearchText.s, 1, #PB_String_NoCase) <> #False
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            AddGadgetItem(#Gadget_Recipeview_Recipenames, #AtTheEndOfTheList, Recipes()\Recipename.s  + #LF$  + Recipes()\RecipeCategory.s, ImageID(#Image_Recipeview_List))
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            PseudoCounter.i + 1
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Info",  "No string match so don't display this line", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
        Next
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ForEach Recipes()
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
          If FindString(Recipes()\Recipename.s, SearchText.s, 1, #PB_String_NoCase) <> #False
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            AddGadgetItem(#Gadget_Recipeview_Recipenames, #AtTheEndOfTheList, Recipes()\Recipename.s  + #LF$  + Recipes()\RecipeCategory.s, ImageID(#Image_Recipeview_List))
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            PseudoCounter.i + 1
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Info",  "No string match so don't display this line", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Next
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Info",  "No search text so do not proceed", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to do as Return wasn't pressed from the search bar", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_Recipeview_Recipenames)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_Recipeview_Recipenames, #FirstItemInList)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetItemState(#Gadget_Recipeview_Recipenames, #FirstItemInList, #PB_ListIcon_Selected)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records",   #Empty$, Str(CountGadgetItems(#Gadget_Recipeview_Recipenames)))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PostEvent(#PB_Event_Gadget, #Window_Recipeview, #Gadget_Recipeview_Recipenames, #PB_EventType_Change)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_Recipeview_Recipesearch)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There were no PDF recipes files found in the directory", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 224
; FirstLine = 179
; Folding = -
; EnableAsm
; EnableXP