﻿;==========================================================================================================================================================
; Load the recipe into the webgadget to display it
;==========================================================================================================================================================

Procedure ShowRecipe()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Recipeview_Recipenames)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i >= 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\LastSelectedRecipe.i  = CurrentLine.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    RecipeName.s = GetGadgetItemText(#Gadget_Recipeview_Recipenames, CurrentLine.i, 0)  ;: Debug RecipeName.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    RecipePath.s = GetGadgetItemText(#Gadget_Recipeview_Recipenames, CurrentLine.i, 1)  ;: Debug RecipePath.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If RecipePath.s + RecipeName.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Current",   #Empty$, Str(CurrentLine.i))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      NumberOfSeparators.i = CountString(RecipePath.s, "\")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NumberOfSeparators.i > 1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipecategory,    StringField(RecipePath.s, NumberOfSeparators.i - 1, "\"))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipesubcategory, StringField(RecipePath.s, NumberOfSeparators.i,     "\"))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      ElseIf NumberOfSeparators.i = 1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipecategory,    StringField(RecipePath.s, NumberOfSeparators.i,     "\"))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipesubcategory, #Empty$)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipecategory,    #Empty$)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Recipeview_Recipesubcategory, #Empty$)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Recipeview_Recipeview, RecipePath.s + RecipeName.s  + ".pdf")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetActiveGadget(#Gadget_Recipeview_Recipenames)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_Recipeview_Recipenames, Program\LastSelectedRecipe.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemState(#Gadget_Recipeview_Recipenames, Program\LastSelectedRecipe.i, #PB_ListIcon_Selected)      
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else

      SetInfoBarArea("Headings",  "Warn",    "The recipe path and recipe name were empty", #PB_Compiler_Procedure)

    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",    "There is no current line to display", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 158
; FirstLine = 117
; Folding = -
; EnableAsm
; EnableXP