﻿;==========================================================================================================================================================
; Scan recipe directory and load filenames
;==========================================================================================================================================================

Procedure GetRecipeDirectory()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the pdf recipe directory that we need to scan
  ;------------------------------------------------------------------------------------------------
  
  Recipespath.s = PathRequester("What directory to search?", "D:\bangf\Documents\Sue Bolvary (Mookie)\Cooking & Recipes\")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Recipespath.s  <> #Empty$
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_Recipeview_Recipenames)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_Recipeview_Recipedirectory, Recipespath.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the recipe names to a linked list with their category name
    ;----------------------------------------------------------------------------------------------
    
    SearchEngine(Recipespath.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the directory name to the form and save it to an ini file
    ;----------------------------------------------------------------------------------------------
    
    Program\LastDirectorySearched.s = Recipespath.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "The user cancelled the operation", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.61 (Windows - x86)
; Folding = -
; EnableAsm
; EnableXP