﻿;==========================================================================================================================================================
; Turn time updating on in the title bar
;==========================================================================================================================================================

Procedure ToggleTitleClock()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Program\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Program\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    KillTimer_(WindowID(#Window_Recipeview), #TitleClockTimerEvent)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_Recipeview, #Fish + #Program + #Version)
    
    ;----------------------------------------------------------------------------------------------
    ; SetDate(#Window_Recipeview)
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", "The titlebar clock is now switched off", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  ElseIf Program\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Program\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Create the permanent timer
    ;----------------------------------------------------------------------------------------------
    
    SetTimer_(WindowID(#Window_Recipeview), #TitleClockTimerEvent, 1000, @TitleClock())    ; 1000 = 1 second
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info",  "The titlebar clock is now switched on", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 62
; FirstLine = 25
; Folding = -
; EnableXP